#include <stdlib.h>
#include <stdarg.h>
#include <stdio.h>
#include <sys/types.h>
#include <dirent.h>
#include <sys/stat.h>

#define REQUEST_DIR "./web"
int
main (int argc, char *argv[])
{

  int i, odd, size, lSize;
  FILE *pFile;
  unsigned char *buffer;
  DIR *dirp;
  char type[20];
  struct dirent *dp;
  struct stat buf;
  char *rightstr (char *string, int number);

  dirp = opendir (REQUEST_DIR);
  chdir (REQUEST_DIR);

  odd = 0;
  printf ("\tdb ");

  /* Look at each entry in turn */
  while ((dp = readdir (dirp)) != NULL)
    {

      /*Now stat the file to get more info */
      if (stat (dp->d_name, &buf) == -1)
	perror ("stat\n");

      /* if (S_ISDIR (buf.st_mode))
         printf ("%s is a directory\n", dp->d_name);
         else */

      if (S_ISREG (buf.st_mode))
	{
	  /* printf ("%s is a file\n", dp->d_name); */

	  /* PRINT lengte bestandsnaam, bestandsnaam */
	  printf ("H\'%02x\',\"%s\",", strlen (dp->d_name), dp->d_name);

	  /* Bepaal content-type aan de hand van de extensie 
	     Uit te breiden indien nodig.
	   */
	  strcpy (type, "text/html");
	  if (strcmp (rightstr (dp->d_name, 4), ".jpg") == 0)
	    {
	      strcpy (type, "image/jpeg");
	    }
	  if (strcmp (rightstr (dp->d_name, 4), ".gif") == 0)
	    {
	      strcpy (type, "image/gif");
	    }

	  /* 1. PRINT lengte van het bestand */
	  pFile = fopen (dp->d_name, "rb");
	  if (pFile == NULL)
	    exit (1);

	  /* obtain file size. */
	  fseek (pFile, 0, SEEK_END);
	  lSize = ftell (pFile);

	  size = lSize + strlen (type) + 2;	/* Inhoud bestand + content-type + 0A + 0A */
	  printf ("H\'%02x\',", size & 255);
	  printf ("H\'%02x\',", size >> 8);

	  rewind (pFile);

	  /* 2. PRINT bestands-type 0A 0A */
	  printf ("\"%s\",", type);
	  odd = (odd + strlen (dp->d_name) + strlen (type) + 1) & 1;
	  if (odd == 0)
	    {
	      printf ("H'0A',H'0A'\n\tdb ");
	    }
	  else
	    {
	      printf ("H'0A'\n\tdb H'0A',");
	    }

	  /* allocate memory to contain the whole file. */
	  buffer = (char *) malloc (lSize);
	  if (buffer == NULL)
	    exit (2);

	  /* copy the file into the buffer. */
	  fread (buffer, 1, lSize, pFile);

	  /* the whole file is loaded in the buffer. */

	  /* 3. PRINT lijst met bytes */
	  for (i = 0; i < lSize; i++)
	    {
	      odd = odd + 1;
	      if (odd <= 19)
		{
		  printf ("H\'%02x\',", buffer[i]);
		}
	      if (odd == 20)
		{
		  printf ("H\'%02x\'\n\tdb ", buffer[i]);
		  odd = 0;
		}
	    }

	  /* terminate */
	  fclose (pFile);
	  free (buffer);

	}
    }
  (void) closedir (dirp);
  printf ("H'00'\n");

  return (0);
}

char *
rightstr (char *string, int number)
{
  int x;

  x = strlen (string) - number;
  if (x > 0)
    return (string + x);
  return (string);
}
